// MyTronBot.cc
//
// This is the code file that you will modify in order to create your entry.

#include "time_util.h"
#include "Map.h"
#include "UCT.h"
#include "SFMT.h"
#include <string>
#include <vector>

int makeMove(Map& map, UCTSearch& search,
        uint64_t start_time, int search_time)
{
    return search.search(map, start_time, search_time);
}

int main() {
    init_gen_rand(0xF00F);
    init_timer();
    int search_time = 900;
    UCTSearch* search = new UCTSearch();
    while (true)
    {
        Map map;
        uint64_t start_time = millis();
        Map::makeMove(makeMove(map, *search, start_time, search_time));
#ifdef TRACE_TREE
        search->print_tree = true;
        search->searchTree(map);
        search->print_tree = false;
#endif
    }
    return 0;
}
