
#include "time_util.h"

#if defined(_MSC_VER)

#include <Windows.h>

uint64_t perf_freq;

void init_timer(void)
{
    LARGE_INTEGER li;
    QueryPerformanceFrequency(&li);
    perf_freq = li.QuadPart;
}

uint64_t millis(void)
{
    LARGE_INTEGER count;
    QueryPerformanceCounter(&count);
    return count.QuadPart / (perf_freq / 1000);
}

#else

#include <sys/time.h>

void init_timer(void) { }

uint64_t millis()
{
    timeval now;
    uint64_t millis;
    gettimeofday(&now, 0);
    millis = now.tv_sec * 1000;
    millis += now.tv_usec / 1000;
    return millis;
}

#endif

